// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Aspect_Window_HeaderFile
#define _Aspect_Window_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineHandle_HeaderFile
#include <Standard_DefineHandle.hxx>
#endif
#ifndef _Handle_Aspect_Window_HeaderFile
#include <Handle_Aspect_Window.hxx>
#endif

#ifndef _Aspect_Background_HeaderFile
#include <Aspect_Background.hxx>
#endif
#ifndef _Aspect_GradientBackground_HeaderFile
#include <Aspect_GradientBackground.hxx>
#endif
#ifndef _Aspect_FillMethod_HeaderFile
#include <Aspect_FillMethod.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _MMgt_TShared_HeaderFile
#include <MMgt_TShared.hxx>
#endif
#ifndef _Quantity_NameOfColor_HeaderFile
#include <Quantity_NameOfColor.hxx>
#endif
#ifndef _Aspect_GradientFillMethod_HeaderFile
#include <Aspect_GradientFillMethod.hxx>
#endif
#ifndef _Aspect_TypeOfResize_HeaderFile
#include <Aspect_TypeOfResize.hxx>
#endif
#ifndef _Quantity_Ratio_HeaderFile
#include <Quantity_Ratio.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class Aspect_WindowDefinitionError;
class Aspect_WindowError;
class Aspect_Background;
class Quantity_Color;
class Aspect_GradientBackground;



class Aspect_Window : public MMgt_TShared {

public:

  //! Modifies the window background. <br>
  Standard_EXPORT     void SetBackground(const Aspect_Background& ABack) ;
  //! Modifies the window background from a Named Color. <br>
  Standard_EXPORT     void SetBackground(const Quantity_NameOfColor theNameOfColor) ;
  //! Modifies the window background. <br>
  Standard_EXPORT     void SetBackground(const Quantity_Color& color) ;
  //! Modifies the window gradient background. <br>
  Standard_EXPORT     void SetBackground(const Aspect_GradientBackground& ABackground) ;
  //! Modifies the window gradient background. <br>
  Standard_EXPORT     void SetBackground(const Quantity_Color& theFirstColor,const Quantity_Color& theSecondColor,const Aspect_GradientFillMethod theFillMethod) ;
  //! Opens the window <me>. <br>
  Standard_EXPORT   virtual  void Map() const = 0;
  //! Closes the window <me>. <br>
  Standard_EXPORT   virtual  void Unmap() const = 0;
  //! Apply the resizing to the window <me>. <br>
  Standard_EXPORT   virtual  Aspect_TypeOfResize DoResize() const = 0;
  //! Apply the mapping change to the window <me>. <br>
//! and returns TRUE if the window is mapped at screen. <br>
  Standard_EXPORT   virtual  Standard_Boolean DoMapping() const = 0;
  //! Destroy the Window <br>
  Standard_EXPORT   virtual  void Destroy()  = 0;
  //! Returns the window background. <br>
  Standard_EXPORT     Aspect_Background Background() const;
  //! Returns the current image background fill mode. <br>
  Standard_EXPORT     Aspect_FillMethod BackgroundFillMethod() const;
  //! Returns the window gradient background. <br>
  Standard_EXPORT     Aspect_GradientBackground GradientBackground() const;
  //! Returns True if the window <me> is opened <br>
//!	    and False if the window is closed. <br>
  Standard_EXPORT   virtual  Standard_Boolean IsMapped() const = 0;
  //! Returns True if the window <me> is virtual <br>
  Standard_EXPORT     Standard_Boolean IsVirtual() const;
  //! Setup the virtual state <br>
  Standard_EXPORT     void SetVirtual(const Standard_Boolean theVirtual) ;
  //! Returns The Window RATIO equal to the physical <br>
//!	    WIDTH/HEIGHT dimensions <br>
  Standard_EXPORT   virtual  Quantity_Ratio Ratio() const = 0;
  //! Returns The Window POSITION in PIXEL <br>
  Standard_EXPORT   virtual  void Position(Standard_Integer& X1,Standard_Integer& Y1,Standard_Integer& X2,Standard_Integer& Y2) const = 0;
  //! Returns The Window SIZE in PIXEL <br>
  Standard_EXPORT   virtual  void Size(Standard_Integer& Width,Standard_Integer& Height) const = 0;




  DEFINE_STANDARD_RTTI(Aspect_Window)

protected:

  //! Initializes the datas of a Window. <br>
  Standard_EXPORT   Aspect_Window();

Aspect_Background MyBackground;
Aspect_GradientBackground MyGradientBackground;
Aspect_FillMethod MyBackgroundFillMethod;
Standard_Boolean MyIsVirtual;


private: 




};





// other Inline functions and methods (like "C++: function call" methods)


#endif
