// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Expr_BinaryExpression_HeaderFile
#define _Expr_BinaryExpression_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineHandle_HeaderFile
#include <Standard_DefineHandle.hxx>
#endif
#ifndef _Handle_Expr_BinaryExpression_HeaderFile
#include <Handle_Expr_BinaryExpression.hxx>
#endif

#ifndef _Handle_Expr_GeneralExpression_HeaderFile
#include <Handle_Expr_GeneralExpression.hxx>
#endif
#ifndef _Expr_GeneralExpression_HeaderFile
#include <Expr_GeneralExpression.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_Expr_NamedUnknown_HeaderFile
#include <Handle_Expr_NamedUnknown.hxx>
#endif
class Expr_GeneralExpression;
class Standard_OutOfRange;
class Standard_NumericError;
class Expr_InvalidOperand;
class Expr_NamedUnknown;


//! Defines all binary expressions. The order of the two <br>
//!          operands is significant. <br>
class Expr_BinaryExpression : public Expr_GeneralExpression {

public:

  
       const Handle_Expr_GeneralExpression& FirstOperand() const;
  
       const Handle_Expr_GeneralExpression& SecondOperand() const;
  //! Sets first operand of <me> <br>
//!          Raises InvalidOperand if exp = me <br>
  Standard_EXPORT     void SetFirstOperand(const Handle(Expr_GeneralExpression)& exp) ;
  //! Sets second operand of <me> <br>
//!          Raises InvalidOperand if <exp> contains <me>. <br>
  Standard_EXPORT     void SetSecondOperand(const Handle(Expr_GeneralExpression)& exp) ;
  //! returns the number of sub-expressions contained <br>
//!          in <me> ( >= 0) <br>
  Standard_EXPORT     Standard_Integer NbSubExpressions() const;
  //! returns the <I>-th sub-expression of <me> <br>
//!          raises OutOfRange if <I> > NbSubExpressions(me) <br>
  Standard_EXPORT    const Handle_Expr_GeneralExpression& SubExpression(const Standard_Integer I) const;
  //! Does <me> contain NamedUnknown ? <br>
  Standard_EXPORT     Standard_Boolean ContainsUnknowns() const;
  //! Tests if <me> contains <exp>. <br>
  Standard_EXPORT     Standard_Boolean Contains(const Handle(Expr_GeneralExpression)& exp) const;
  //! Replaces all occurences of <var> with <with> in <me>. <br>
//!          Raises InvalidOperand if <with> contains <me>. <br>
  Standard_EXPORT     void Replace(const Handle(Expr_NamedUnknown)& var,const Handle(Expr_GeneralExpression)& with) ;
  //! Returns a GeneralExpression after replacement of <br>
//!          NamedUnknowns by an associated expression and after <br>
//!          values computation. <br>
  Standard_EXPORT     Handle_Expr_GeneralExpression Simplified() const;




  DEFINE_STANDARD_RTTI(Expr_BinaryExpression)

protected:

  //! Sets first operand of <me> <br>
  Standard_EXPORT     void CreateFirstOperand(const Handle(Expr_GeneralExpression)& exp) ;
  //! Sets second operand of <me> <br>
//!          Raises InvalidOperand if <exp> contains <me>. <br>
  Standard_EXPORT     void CreateSecondOperand(const Handle(Expr_GeneralExpression)& exp) ;



private: 


Handle_Expr_GeneralExpression myFirstOperand;
Handle_Expr_GeneralExpression mySecondOperand;


};


#include <Expr_BinaryExpression.lxx>



// other Inline functions and methods (like "C++: function call" methods)


#endif
