// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _FairCurve_BattenLaw_HeaderFile
#define _FairCurve_BattenLaw_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineAlloc_HeaderFile
#include <Standard_DefineAlloc.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _math_Function_HeaderFile
#include <math_Function.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif


//! This class compute the Heigth of an batten <br>
class FairCurve_BattenLaw  : public math_Function {
public:

  DEFINE_STANDARD_ALLOC

  //! Constructor of linear batten with <br>
//!          Heigth : the Heigth at the middle point <br>
//!          Slope  : the geometric slope of the batten <br>
//!          Sliding : Active Length of the batten without extension <br>
  Standard_EXPORT   FairCurve_BattenLaw(const Standard_Real Heigth,const Standard_Real Slope,const Standard_Real Sliding);
  //! Change the value of sliding <br>
        void SetSliding(const Standard_Real Sliding) ;
  //! Change the value of Heigth at the middle point. <br>
        void SetHeigth(const Standard_Real Heigth) ;
  //! Change the value of the geometric slope. <br>
        void SetSlope(const Standard_Real Slope) ;
  //! computes the value of  the heigth for the parameter T <br>
//!          on  the neutral fibber <br>
      virtual  Standard_Boolean Value(const Standard_Real T,Standard_Real& THeigth) ;





protected:





private:



Standard_Real MiddleHeigth;
Standard_Real GeometricSlope;
Standard_Real LengthSliding;


};


#include <FairCurve_BattenLaw.lxx>



// other Inline functions and methods (like "C++: function call" methods)


#endif
