// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Graphic3d_ArrayOfTriangleStrips_HeaderFile
#define _Graphic3d_ArrayOfTriangleStrips_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineHandle_HeaderFile
#include <Standard_DefineHandle.hxx>
#endif
#ifndef _Handle_Graphic3d_ArrayOfTriangleStrips_HeaderFile
#include <Handle_Graphic3d_ArrayOfTriangleStrips.hxx>
#endif

#ifndef _Graphic3d_ArrayOfPrimitives_HeaderFile
#include <Graphic3d_ArrayOfPrimitives.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif



class Graphic3d_ArrayOfTriangleStrips : public Graphic3d_ArrayOfPrimitives {

public:

  //! Creates an array of triangle strips, <br>
//! a polygon can be filled as: <br>
//! 1) creating a single strip defined with his vertexs. <br>
//!    i.e: <br>
//!    myArray = Graphic3d_ArrayOfTriangleStrips(7) <br>
//!    myArray->AddVertex(x1,y1,z1) <br>
//!      .... <br>
//!    myArray->AddVertex(x7,y7,z7) <br>
//! 2) creating separate strips defined with a predefined <br>
//!    number of strips and the number of vertex per strip. <br>
//!    i.e: <br>
//!    myArray = Graphic3d_ArrayOfTriangleStrips(8,2) <br>
//!    myArray->AddBound(4) <br>
//!    myArray->AddVertex(x1,y1,z1) <br>
//!      .... <br>
//!    myArray->AddVertex(x4,y4,z4) <br>
//!    myArray->AddBound(4) <br>
//!    myArray->AddVertex(x5,y5,z5) <br>
//!      .... <br>
//!    myArray->AddVertex(x8,y8,z8) <br>
//! <br>
//! <maxVertexs> defined the maximun allowed vertex number in the array. <br>
//! <maxStrips> defined the maximun allowed strip number in the array. <br>
//! The number of triangle really drawn is : <br>
//! VertexNumber()-2*Min(1,BoundNumber()) <br>
//!  Warning: <br>
//! When <hasVNormals> is TRUE , you must use one of <br>
//!      AddVertex(Point,Normal) <br>
//!  or  AddVertex(Point,Normal,Color) <br>
//!  or  AddVertex(Point,Normal,Texel) methods. <br>
//! When <hasVColors> is TRUE , you must use one of <br>
//!      AddVertex(Point,Color) <br>
//!  or  AddVertex(Point,Normal,Color) methods. <br>
//! When <hasTexels> is TRUE , you must use one of <br>
//!      AddVertex(Point,Texel) <br>
//!  or  AddVertex(Point,Normal,Texel) methods. <br>
//! When <hasBColors> is TRUE , <maxBounds> must be > 0 and <br>
//!      you must use the <br>
//!      AddBound(number,Color) method. <br>
//!  Warning: <br>
//! the user is responsible about the orientation of the strip <br>
//! depending of the order of the created vertex and this <br>
//! orientation must be coherent with the vertex normal optionnaly <br>
//! given at each vertex (See the Orientate() methods). <br>
  Standard_EXPORT   Graphic3d_ArrayOfTriangleStrips(const Standard_Integer maxVertexs,const Standard_Integer maxStrips = 0,const Standard_Boolean hasVNormals = Standard_False,const Standard_Boolean hasVColors = Standard_False,const Standard_Boolean hasSColors = Standard_False,const Standard_Boolean hasTexels = Standard_False);




  DEFINE_STANDARD_RTTI(Graphic3d_ArrayOfTriangleStrips)

protected:




private: 




};





// other Inline functions and methods (like "C++: function call" methods)


#endif
