// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _IGESSolid_Shell_HeaderFile
#define _IGESSolid_Shell_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineHandle_HeaderFile
#include <Standard_DefineHandle.hxx>
#endif
#ifndef _Handle_IGESSolid_Shell_HeaderFile
#include <Handle_IGESSolid_Shell.hxx>
#endif

#ifndef _Handle_IGESSolid_HArray1OfFace_HeaderFile
#include <Handle_IGESSolid_HArray1OfFace.hxx>
#endif
#ifndef _Handle_TColStd_HArray1OfInteger_HeaderFile
#include <Handle_TColStd_HArray1OfInteger.hxx>
#endif
#ifndef _IGESData_IGESEntity_HeaderFile
#include <IGESData_IGESEntity.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
#ifndef _Handle_IGESSolid_Face_HeaderFile
#include <Handle_IGESSolid_Face.hxx>
#endif
class IGESSolid_HArray1OfFace;
class TColStd_HArray1OfInteger;
class Standard_DimensionMismatch;
class Standard_OutOfRange;
class IGESSolid_Face;


//! defines Shell, Type <514> Form Number <1> <br>
//!          in package IGESSolid <br>
//!          Shell entity is a connected entity of dimensionality 2 <br>
//!          which divides R3 into two arcwise connected open subsets, <br>
//!          one of which is finite. Inside of the shell is defined to <br>
//!          be the finite region. <br>
//!          From IGES-5.3, Form can be <1> for Closed or <2> for Open <br>
class IGESSolid_Shell : public IGESData_IGESEntity {

public:

  
  Standard_EXPORT   IGESSolid_Shell();
  //! This method is used to set the fields of the class Shell <br>
//!       - allFaces  : the faces comprising the shell <br>
//!       - allOrient : the orientation flags of the shell <br>
//! raises exception if length of allFaces & allOrient do not match <br>
  Standard_EXPORT     void Init(const Handle(IGESSolid_HArray1OfFace)& allFaces,const Handle(TColStd_HArray1OfInteger)& allOrient) ;
  //! Tells if a Shell is Closed, i.e. if its FormNumber is 1 <br>
//!           (this is the default) <br>
  Standard_EXPORT     Standard_Boolean IsClosed() const;
  //! Sets or Unsets the Closed status (FormNumber = 1 else 2) <br>
  Standard_EXPORT     void SetClosed(const Standard_Boolean closed) ;
  //! returns the number of the face entities in the shell <br>
  Standard_EXPORT     Standard_Integer NbFaces() const;
  //! returns the Index'th face entity of the shell <br>
//! raises exception if Index <= 0 or Index > NbFaces() <br>
  Standard_EXPORT     Handle_IGESSolid_Face Face(const Standard_Integer Index) const;
  //! returns the orientation of Index'th face w.r.t the direction of <br>
//! the underlying surface <br>
//! raises exception if Index <= 0 or Index > NbFaces() <br>
  Standard_EXPORT     Standard_Boolean Orientation(const Standard_Integer Index) const;




  DEFINE_STANDARD_RTTI(IGESSolid_Shell)

protected:




private: 


Handle_IGESSolid_HArray1OfFace theFaces;
Handle_TColStd_HArray1OfInteger theOrientation;


};





// other Inline functions and methods (like "C++: function call" methods)


#endif
