// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Law_Interpol_HeaderFile
#define _Law_Interpol_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineHandle_HeaderFile
#include <Standard_DefineHandle.hxx>
#endif
#ifndef _Handle_Law_Interpol_HeaderFile
#include <Handle_Law_Interpol.hxx>
#endif

#ifndef _Law_BSpFunc_HeaderFile
#include <Law_BSpFunc.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
class TColgp_Array1OfPnt2d;


//! Provides an evolution law that interpolates a set <br>
//!          of parameter and value pairs (wi, radi) <br>
class Law_Interpol : public Law_BSpFunc {

public:

  //! Constructs an empty interpolative evolution law. <br>
//! The function Set is used to define the law. <br>
  Standard_EXPORT   Law_Interpol();
  
//!    Defines this evolution law by interpolating the set of 2D <br>
//! points ParAndRad. The Y coordinate of a point of <br>
//! ParAndRad is the value of the function at the parameter <br>
//! point given by its X coordinate. <br>
//! If Periodic is true, this function is assumed to be periodic. <br>
//! Warning <br>
//! -   The X coordinates of points in the table ParAndRad <br>
//!   must be given in ascendant order. <br>
//! -   If Periodic is true, the first and last Y coordinates of <br>
//!   points in the table ParAndRad are assumed to be <br>
//!   equal. In addition, with the second syntax, Dd and Df <br>
//!   are also assumed to be equal. If this is not the case, <br>
//!   Set uses the first value(s) as last value(s). <br>
  Standard_EXPORT     void Set(const TColgp_Array1OfPnt2d& ParAndRad,const Standard_Boolean Periodic = Standard_False) ;
  
  Standard_EXPORT     void SetInRelative(const TColgp_Array1OfPnt2d& ParAndRad,const Standard_Real Ud,const Standard_Real Uf,const Standard_Boolean Periodic = Standard_False) ;
  
//!    Defines this evolution law by interpolating the set of 2D <br>
//! points ParAndRad. The Y coordinate of a point of <br>
//! ParAndRad is the value of the function at the parameter <br>
//! point given by its X coordinate. <br>
//! If Periodic is true, this function is assumed to be periodic. <br>
//! In the second syntax, Dd and Df define the values of <br>
//! the first derivative of the function at its first and last points. <br>
//! Warning <br>
//! -   The X coordinates of points in the table ParAndRad <br>
//!   must be given in ascendant order. <br>
//! -   If Periodic is true, the first and last Y coordinates of <br>
//!   points in the table ParAndRad are assumed to be <br>
//!   equal. In addition, with the second syntax, Dd and Df <br>
//!   are also assumed to be equal. If this is not the case, <br>
//!   Set uses the first value(s) as last value(s). <br>
  Standard_EXPORT     void Set(const TColgp_Array1OfPnt2d& ParAndRad,const Standard_Real Dd,const Standard_Real Df,const Standard_Boolean Periodic = Standard_False) ;
  
  Standard_EXPORT     void SetInRelative(const TColgp_Array1OfPnt2d& ParAndRad,const Standard_Real Ud,const Standard_Real Uf,const Standard_Real Dd,const Standard_Real Df,const Standard_Boolean Periodic = Standard_False) ;




  DEFINE_STANDARD_RTTI(Law_Interpol)

protected:




private: 




};





// other Inline functions and methods (like "C++: function call" methods)


#endif
