// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Law_S_HeaderFile
#define _Law_S_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineHandle_HeaderFile
#include <Standard_DefineHandle.hxx>
#endif
#ifndef _Handle_Law_S_HeaderFile
#include <Handle_Law_S.hxx>
#endif

#ifndef _Law_BSpFunc_HeaderFile
#include <Law_BSpFunc.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif


//! Describes an "S" evolution law. <br>
class Law_S : public Law_BSpFunc {

public:

  //! Constructs an empty "S" evolution law. <br>
  Standard_EXPORT   Law_S();
  
//! Defines this S evolution law by assigning both: <br>
//! -   the bounds Pdeb and Pfin of the parameter, and <br>
//! -   the values Valdeb and Valfin of the function at these <br>
//!   two parametric bounds. <br>
//! The function is assumed to have the first derivatives <br>
//! equal to 0 at the two parameter points Pdeb and Pfin. <br>
  Standard_EXPORT     void Set(const Standard_Real Pdeb,const Standard_Real Valdeb,const Standard_Real Pfin,const Standard_Real Valfin) ;
  //! Defines this S evolution law by assigning <br>
//! -   the bounds Pdeb and Pfin of the parameter, <br>
//! -   the values Valdeb and Valfin of the function at these <br>
//!   two parametric bounds, and <br>
//! -   the values Ddeb and Dfin of the first derivative of the <br>
//!   function at these two parametric bounds. <br>
  Standard_EXPORT     void Set(const Standard_Real Pdeb,const Standard_Real Valdeb,const Standard_Real Ddeb,const Standard_Real Pfin,const Standard_Real Valfin,const Standard_Real Dfin) ;




  DEFINE_STANDARD_RTTI(Law_S)

protected:




private: 




};





// other Inline functions and methods (like "C++: function call" methods)


#endif
