// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _Prs3d_AngleAspect_HeaderFile
#define _Prs3d_AngleAspect_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineHandle_HeaderFile
#include <Standard_DefineHandle.hxx>
#endif
#ifndef _Handle_Prs3d_AngleAspect_HeaderFile
#include <Handle_Prs3d_AngleAspect.hxx>
#endif

#ifndef _Handle_Prs3d_LineAspect_HeaderFile
#include <Handle_Prs3d_LineAspect.hxx>
#endif
#ifndef _Handle_Prs3d_ArrowAspect_HeaderFile
#include <Handle_Prs3d_ArrowAspect.hxx>
#endif
#ifndef _Handle_Prs3d_TextAspect_HeaderFile
#include <Handle_Prs3d_TextAspect.hxx>
#endif
#ifndef _Prs3d_CompositeAspect_HeaderFile
#include <Prs3d_CompositeAspect.hxx>
#endif
class Prs3d_LineAspect;
class Prs3d_ArrowAspect;
class Prs3d_TextAspect;


//! A framework for defining how an angle will be <br>
//! displayed in a presentation. Aspects of angle display include: <br>
//! -   display of the arrow pointing to the angle <br>
//! -   display of the line making up the shaft of the arrow <br>
//! -   display of the text referring to the angle. <br>
//!   The definition set by this class is then passed to the <br>
//! attribute manager Prs3d_Drawer. <br>
//! Any object which requires a value for angle aspect as <br>
//! an argument may then be given the attribute manager <br>
//! as a substitute argument in the form of a field such as <br>
//! myDrawer for example. <br>
class Prs3d_AngleAspect : public Prs3d_CompositeAspect {

public:

  
  Standard_EXPORT   Prs3d_AngleAspect();
  //! Returns the setting determining how the line making <br>
//! up the shaft of the arrow will be displayed. <br>
  Standard_EXPORT     Handle_Prs3d_LineAspect LineAspect() const;
  //! Sets how the line making up the shaft of an arrow will be displayed. <br>
  Standard_EXPORT     void SetLineAspect(const Handle(Prs3d_LineAspect)& anAspect) ;
  //! Returns the setting determining how text in the <br>
//! presentation of an angle will be displayed. <br>
  Standard_EXPORT     Handle_Prs3d_TextAspect TextAspect() const;
  //! Sets how text in the presentation of an angle will be displayed. <br>
  Standard_EXPORT     void SetTextAspect(const Handle(Prs3d_TextAspect)& anAspect) ;
  //! Returns the setting determining how an arrow head <br>
//! which points to an angle will be displayed. <br>
  Standard_EXPORT     Handle_Prs3d_ArrowAspect ArrowAspect() const;
  //! Sets how an arrow head which points to an angle will be displayed. <br>
  Standard_EXPORT     void SetArrowAspect(const Handle(Prs3d_ArrowAspect)& anAspect) ;




  DEFINE_STANDARD_RTTI(Prs3d_AngleAspect)

protected:




private: 


Handle_Prs3d_LineAspect myLineAspect;
Handle_Prs3d_ArrowAspect myArrowAspect;
Handle_Prs3d_TextAspect myTextAspect;


};





// other Inline functions and methods (like "C++: function call" methods)


#endif
