// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _TDocStd_XLink_HeaderFile
#define _TDocStd_XLink_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineHandle_HeaderFile
#include <Standard_DefineHandle.hxx>
#endif
#ifndef _Handle_TDocStd_XLink_HeaderFile
#include <Handle_TDocStd_XLink.hxx>
#endif

#ifndef _TCollection_AsciiString_HeaderFile
#include <TCollection_AsciiString.hxx>
#endif
#ifndef _TDocStd_XLinkPtr_HeaderFile
#include <TDocStd_XLinkPtr.hxx>
#endif
#ifndef _TDF_Attribute_HeaderFile
#include <TDF_Attribute.hxx>
#endif
#ifndef _Handle_TDF_Reference_HeaderFile
#include <Handle_TDF_Reference.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Handle_TDF_AttributeDelta_HeaderFile
#include <Handle_TDF_AttributeDelta.hxx>
#endif
#ifndef _Handle_TDF_Attribute_HeaderFile
#include <Handle_TDF_Attribute.hxx>
#endif
#ifndef _Handle_TDF_RelocationTable_HeaderFile
#include <Handle_TDF_RelocationTable.hxx>
#endif
#ifndef _Standard_OStream_HeaderFile
#include <Standard_OStream.hxx>
#endif
class TDocStd_XLinkRoot;
class TDocStd_XLinkIterator;
class TDF_Label;
class TDF_Reference;
class Standard_GUID;
class TCollection_AsciiString;
class TDF_AttributeDelta;
class TDF_Attribute;
class TDF_RelocationTable;


//! An attribute to store the path and the entry of <br>
//! external links. <br>
//!  These refer from one data structure to a data <br>
//!  structure in another document. <br>
class TDocStd_XLink : public TDF_Attribute {

public:

  //! Sets an empty external reference, at the label aLabel. <br>
  Standard_EXPORT   static  Handle_TDocStd_XLink Set(const TDF_Label& atLabel) ;
  //! Initializes fields. <br>
  Standard_EXPORT   TDocStd_XLink();
  //!  Updates the data referenced in this external link attribute. <br>
  Standard_EXPORT     Handle_TDF_Reference Update() ;
  //! Returns the ID of the attribute. <br>
//! <br>
  Standard_EXPORT    const Standard_GUID& ID() const;
  //! Returns the GUID for external links. <br>
//! <br>
  Standard_EXPORT   static const Standard_GUID& GetID() ;
  //! Sets the name aDocEntry for the external <br>
//! document in this external link attribute. <br>
  Standard_EXPORT     void DocumentEntry(const TCollection_AsciiString& aDocEntry) ;
  //! Returns the contents of the document identified by aDocEntry. <br>
//! aDocEntry provides external data to this external link attribute. <br>
  Standard_EXPORT    const TCollection_AsciiString& DocumentEntry() const;
  //! Sets the label entry for this external link attribute with the label aLabel. <br>
//! aLabel pilots the importation of data from the document entry. <br>
  Standard_EXPORT     void LabelEntry(const TDF_Label& aLabel) ;
  //!  Sets the label entry for this external link attribute <br>
//! as a document identified by aLabEntry. <br>
  Standard_EXPORT     void LabelEntry(const TCollection_AsciiString& aLabEntry) ;
  //! Returns the contents of the field <myLabelEntry>. <br>
//! <br>
  Standard_EXPORT    const TCollection_AsciiString& LabelEntry() const;
  //! Updates the XLinkRoot attribute by adding <me> <br>
//!          to its list. <br>
  Standard_EXPORT     void AfterAddition() ;
  //! Updates the XLinkRoot attribute by removing <me> <br>
//!          from its list. <br>
  Standard_EXPORT     void BeforeRemoval() ;
  //! Something to do before applying <anAttDelta>. <br>
  Standard_EXPORT   virtual  Standard_Boolean BeforeUndo(const Handle(TDF_AttributeDelta)& anAttDelta,const Standard_Boolean forceIt = Standard_False) ;
  //! Something to do after applying <anAttDelta>. <br>
  Standard_EXPORT   virtual  Standard_Boolean AfterUndo(const Handle(TDF_AttributeDelta)& anAttDelta,const Standard_Boolean forceIt = Standard_False) ;
  //! Returns a null handle. Raise allways for ,it is <br>
//!          nonsense to use this method. <br>
  Standard_EXPORT     Handle_TDF_Attribute BackupCopy() const;
  //! Does nothing. <br>
  Standard_EXPORT     void Restore(const Handle(TDF_Attribute)& anAttribute) ;
  //! Returns a null handle. <br>
  Standard_EXPORT     Handle_TDF_Attribute NewEmpty() const;
  //! Does nothing. <br>
  Standard_EXPORT     void Paste(const Handle(TDF_Attribute)& intoAttribute,const Handle(TDF_RelocationTable)& aRelocationTable) const;
  //! Dumps the attribute on <aStream>. <br>
  Standard_EXPORT     Standard_OStream& Dump(Standard_OStream& anOS) const;


friend class TDocStd_XLinkRoot;
friend class TDocStd_XLinkIterator;


  DEFINE_STANDARD_RTTI(TDocStd_XLink)

protected:




private: 

  //! Sets the field <myNext> with <anXLinkPtr>. <br>
//! <br>
        void Next(const TDocStd_XLinkPtr& anXLinkPtr) ;
  //! Returns the contents of the field <myNext>. <br>
//! <br>
        TDocStd_XLinkPtr Next() const;

TCollection_AsciiString myDocEntry;
TCollection_AsciiString myLabelEntry;
TDocStd_XLinkPtr myNext;


};


#include <TDocStd_XLink.lxx>



// other Inline functions and methods (like "C++: function call" methods)


#endif
