// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _XSControl_SignTransferStatus_HeaderFile
#define _XSControl_SignTransferStatus_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineHandle_HeaderFile
#include <Standard_DefineHandle.hxx>
#endif
#ifndef _Handle_XSControl_SignTransferStatus_HeaderFile
#include <Handle_XSControl_SignTransferStatus.hxx>
#endif

#ifndef _Handle_XSControl_TransferReader_HeaderFile
#include <Handle_XSControl_TransferReader.hxx>
#endif
#ifndef _Handle_Transfer_TransientProcess_HeaderFile
#include <Handle_Transfer_TransientProcess.hxx>
#endif
#ifndef _IFSelect_Signature_HeaderFile
#include <IFSelect_Signature.hxx>
#endif
#ifndef _Standard_CString_HeaderFile
#include <Standard_CString.hxx>
#endif
#ifndef _Handle_Standard_Transient_HeaderFile
#include <Handle_Standard_Transient.hxx>
#endif
#ifndef _Handle_Interface_InterfaceModel_HeaderFile
#include <Handle_Interface_InterfaceModel.hxx>
#endif
class XSControl_TransferReader;
class Transfer_TransientProcess;
class Standard_Transient;
class Interface_InterfaceModel;


//! This Signatures gives the Transfer Status of an entity, as <br>
//!           recorded in a TransferProcess. It can be : <br>
//!           - Void : not recorded, or recorded as void with no message <br>
//!             (attributes are not taken into account) <br>
//!           - Warning : no result, warning message(s), no fail <br>
//!           - Fail : no result, fail messages (with or without warning) <br>
//!           - Result.. : result, no message (neither warning nor fail) <br>
//!             Result.. i.e. Result:TypeName of the result <br>
//!           - Result../Warning : result, with warning but no fail <br>
//!           - Result../Fail : result, with fail (.e. bad result) <br>
//!           - Fail on run : no result yet recorded, no message, but <br>
//!             an exception occurred while recording the result <br>
//!             (this should not appear and indicates a programming error) <br>
class XSControl_SignTransferStatus : public IFSelect_Signature {

public:

  //! Creates a SignTransferStatus, not initialised <br>
//!           it gives nothing (empty string) <br>
  Standard_EXPORT   XSControl_SignTransferStatus();
  //! Creates a SignTransferStatus, which will work on the current <br>
//!           TransientProcess brought by the TransferReader (its MapReader) <br>
  Standard_EXPORT   XSControl_SignTransferStatus(const Handle(XSControl_TransferReader)& TR);
  //! Sets a TransferReader to work <br>
  Standard_EXPORT     void SetReader(const Handle(XSControl_TransferReader)& TR) ;
  //! Sets a precise map to sign entities <br>
//!           This definition oversedes the creation with a TransferReader <br>
  Standard_EXPORT     void SetMap(const Handle(Transfer_TransientProcess)& TP) ;
  //! Returns the TransientProcess used as precised one <br>
//!           Returns a Null Handle for a creation from a TransferReader <br>
//!           without any further setting <br>
  Standard_EXPORT     Handle_Transfer_TransientProcess Map() const;
  //! Returns the Reader (if created with a Reader) <br>
//!           Returns a Null Handle if not created with a Reader <br>
  Standard_EXPORT     Handle_XSControl_TransferReader Reader() const;
  //! Returns the Signature for a Transient object, as its transfer <br>
//!           status <br>
  Standard_EXPORT     Standard_CString Value(const Handle(Standard_Transient)& ent,const Handle(Interface_InterfaceModel)& model) const;




  DEFINE_STANDARD_RTTI(XSControl_SignTransferStatus)

protected:




private: 


Handle_XSControl_TransferReader theTR;
Handle_Transfer_TransientProcess theTP;


};





// other Inline functions and methods (like "C++: function call" methods)


#endif
