// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _gce_MakeHypr2d_HeaderFile
#define _gce_MakeHypr2d_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_DefineAlloc_HeaderFile
#include <Standard_DefineAlloc.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

#ifndef _gp_Hypr2d_HeaderFile
#include <gp_Hypr2d.hxx>
#endif
#ifndef _gce_Root_HeaderFile
#include <gce_Root.hxx>
#endif
#ifndef _Standard_Real_HeaderFile
#include <Standard_Real.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
class StdFail_NotDone;
class gp_Pnt2d;
class gp_Ax2d;
class gp_Ax22d;
class gp_Hypr2d;


//!This class implements the following algorithms used to <br>
//!          create a 2d Hyperbola from gp. <br>
//!          * Create a 2d Hyperbola from its center and two points: <br>
//!            one on its axis of symmetry giving the major radius, the <br>
//!            other giving the value of the small radius. <br>
//!          * Create a 2d Hyperbola from its major axis and its major <br>
//!            radius and its minor radius. <br>
//! <br>
//! <br>
//!                         ^YAxis <br>
//!                         | <br>
//!                  FirstConjugateBranch <br>
//!                         | <br>
//!        Other            |                Main <br>
//!   --------------------- C ------------------------------>XAxis <br>
//!        Branch           |                Branch <br>
//!                         | <br>
//!                         | <br>
//!                   SecondConjugateBranch <br>
//!                         | <br>
//! <br>
//!  An axis placement (one axis) is associated with the hyperbola. <br>
//!  This axis is the "XAxis" or major axis of the hyperbola. It is <br>
//!  the symmetry axis of the main branch of hyperbola. <br>
//!  The "YAxis" is normal to this axis and pass throught its location <br>
//!  point. It is the minor axis. <br>
//! <br>
//!  The major radius is the distance between the Location point <br>
//!  of the hyperbola C and the vertex of the Main Branch (or the <br>
//!  Other branch). The minor radius is the distance between the <br>
//!  Location point of the hyperbola C and the vertex of the First <br>
//!  (or Second) Conjugate branch. <br>
//!  The major radius can be lower than the minor radius. <br>
class gce_MakeHypr2d  : public gce_Root {
public:

  DEFINE_STANDARD_ALLOC

  //! Constructs a hyperbola <br>
//!   centered on the point Center, where: <br>
//!   -   the major axis of the hyperbola is defined by Center and point S1, <br>
//!   -   the major radius is the distance between Center and S1, and <br>
//!   -   the minor radius is the distance between point S2 and the major axis. <br>
  Standard_EXPORT   gce_MakeHypr2d(const gp_Pnt2d& S1,const gp_Pnt2d& S2,const gp_Pnt2d& Center);
  //! Constructs a hyperbola with major and minor radii MajorRadius and <br>
//!   MinorRadius, where: <br>
//!   -   the center of the hyperbola is the origin of the axis MajorAxis, and <br>
//!   -   the major axis is defined by MajorAxis if Sense <br>
//! is true, or the opposite axis to MajorAxis if Sense is false; or <br>
//! -   centered on the origin of the coordinate system <br>
//!   A, with major and minor radii MajorRadius and <br>
//!   MinorRadius, where its major axis is the "X Axis" <br>
//!   of A (A is the local coordinate system of the hyperbola). <br>
  Standard_EXPORT   gce_MakeHypr2d(const gp_Ax2d& MajorAxis,const Standard_Real MajorRadius,const Standard_Real MinorRadius,const Standard_Boolean Sense);
  //!Creates a Hypr2d centered on the origin of the coordinate system <br>
//!  A, with major and minor radii MajorRadius and <br>
//!  MinorRadius, where its major axis is the "X Axis" <br>
//!  of A (A is the local coordinate system of the hyperbola). <br>
  Standard_EXPORT   gce_MakeHypr2d(const gp_Ax22d& A,const Standard_Real MajorRadius,const Standard_Real MinorRadius);
  //! Returns the constructed hyperbola. <br>
//! Exceptions StdFail_NotDone if no hyperbola is constructed. <br>
  Standard_EXPORT    const gp_Hypr2d& Value() const;
  
  Standard_EXPORT    const gp_Hypr2d& Operator() const;
Standard_EXPORT operator gp_Hypr2d() const;





protected:





private:



gp_Hypr2d TheHypr2d;


};





// other Inline functions and methods (like "C++: function call" methods)


#endif
